## libalog 0.1

=== Makefile ===
#
#  Copyright (c) 2008,
#  Reto Buerki, Adrian-Ken Rueegsegger
#  secunet SwissIT AG
#
#  This file is part of Alog.
#
#  Alog is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation; either version 2.1 of the License, or
#  (at your option) any later version.
#
#  Alog is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with Alog; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
#  MA  02110-1301  USA
#

PREFIX?=$(HOME)/libraries
INSTALL=install

VERSION=`grep " Version" src/alog.ads | cut -d\" -f2`
ALOG=libalog-$(VERSION)
DISTFILES=`ls | grep -v libalog`

SOURCES=src/*
ALI_FILES=lib/*.ali
SO_LIBRARY=libalog.so.0.1

all:
	@mkdir -p lib obj
	@gnatmake -Palog
	@gnatmake -Palog_lib

clean:
	@rm -rf obj/*
	@rm -rf lib/*

distclean:
	@rm -rf obj
	@rm -rf lib

control:
	@rm -f obj/*.adt objects/*.ali
	cd obj && adactl -f ../rules/alog.aru ../src/*.ad[bs]

dist: distclean
	@mkdir -p $(ALOG)
	@cp -R $(DISTFILES) $(ALOG)
	@tar cvjf $(ALOG).tar.bz2 $(ALOG)
	@rm -r $(ALOG)

tests: all
	@obj/runner

install: install_lib

install_lib:
	@mkdir -p $(PREFIX)/include/alog
	@mkdir -p $(PREFIX)/lib/alog
	$(INSTALL) -m 644 $(SOURCES) $(PREFIX)/include/alog
	$(INSTALL) -m 444 $(ALI_FILES) $(PREFIX)/lib/alog
	$(INSTALL) -m 444 lib/$(SO_LIBRARY) $(PREFIX)/lib/alog
	@ln -s $(PREFIX)/lib/alog/$(SO_LIBRARY) $(PREFIX)/lib/alog/libalog.so

## libalog 0.3

=== Makefile ===
#
#  Copyright (c) 2008,
#  Reto Buerki, Adrian-Ken Rueegsegger
#  secunet SwissIT AG
#
#  This file is part of Alog.
#
#  Alog is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation; either version 2.1 of the License, or
#  (at your option) any later version.
#
#  Alog is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with Alog; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
#  MA  02110-1301  USA
#

PREFIX ?= $(HOME)/libraries
INSTALL = install
TARGET ?= "base"

MAJOR = 0
MINOR = 3
VERSION = $(MAJOR).$(MINOR)
ALOG = libalog-$(VERSION)
SO_LIBRARY = libalog.so.$(VERSION)
A_LIBRARY = libalog.a
LIBRARY_KIND = dynamic

SOURCEDIR = src
OBJECTDIR = obj/$(TARGET)
LIBDIR = lib/$(TARGET)
COVDIR = cov/$(TARGET)
PROFDIR = prof/$(TARGET)
ALI_FILES = lib/$(TARGET)/*.ali

TMPDIR = /tmp
DISTDIR = $(TMPDIR)/$(ALOG)
TARBALL = $(ALOG).tar.bz2
PWD = `pwd`

NUM_CPUS := $(shell getconf _NPROCESSORS_ONLN)

all: build_lib

tests: build_tests
	@$(OBJECTDIR)/runner_$(TARGET)

build_lib: prepare
	@gnatmake -p -Palog_$(TARGET) -j$(NUM_CPUS) -XALOG_VERSION="$(VERSION)" -XLIBRARY_KIND="$(LIBRARY_KIND)"

build_tests: prepare
	@gnatmake -p -Palog_$(TARGET)_tests -j$(NUM_CPUS) -XALOG_BUILD="tests"

prepare: $(SOURCEDIR)/alog-version.ads
	@mkdir -p $(COVDIR) $(PROFDIR)

$(SOURCEDIR)/alog-version.ads:
	@echo "package Alog.Version is"                 > $@
	@echo "   Version_Number : constant Float  :="  >> $@
	@echo "      $(VERSION);"                       >> $@
	@echo "end Alog.Version;"                       >> $@

clean:
	@rm -f alog.specs
	@rm -rf $(OBJECTDIR)/lib/*
	@rm -rf $(OBJECTDIR)/*
	@rm -rf $(LIBDIR)/*
	@rm -rf $(COVDIR)/*
	@rm -rf $(PROFDIR)/*

distclean: clean
	@rm -rf obj
	@rm -rf lib
	@rm -rf cov
	@rm -rf prof
	@rm -f $(SOURCEDIR)/alog-version.ads

dist: distclean $(SOURCEDIR)/alog-version.ads
	@echo -n "Creating release tarball '$(ALOG)' ... "
	@mkdir -p $(DISTDIR)
	@cp -R * $(DISTDIR)
	@tar -C $(TMPDIR) -cjf $(TARBALL) $(ALOG)
	@rm -rf $(DISTDIR)
	@echo "DONE"

install: install_lib install_$(LIBRARY_KIND)

install_lib: build_lib
	@mkdir -p $(PREFIX)/include/alog
	@mkdir -p $(PREFIX)/lib/alog
	$(INSTALL) -m 644 $(SOURCEDIR)/* $(PREFIX)/include/alog
	$(INSTALL) -m 444 $(ALI_FILES) $(PREFIX)/lib/alog

install_static:
	$(INSTALL) -m 444 $(LIBDIR)/$(A_LIBRARY) $(PREFIX)/lib/alog

install_dynamic:
	$(INSTALL) -m 444 $(LIBDIR)/$(SO_LIBRARY) $(PREFIX)/lib/alog
	@cd $(PREFIX)/lib/alog && \
	ln -sf $(SO_LIBRARY) libalog.so && \
	ln -sf $(SO_LIBRARY) libalog.so.$(MAJOR)

cov: prepare
	@rm -f $(OBJECTDIR)/cov/*.gcda
	@gnatmake -p -Palog_$(TARGET)_tests -j$(NUM_CPUS) -XALOG_BUILD="coverage"
	@$(OBJECTDIR)/cov/runner_$(TARGET) || true
	@lcov -c -d $(OBJECTDIR)/cov/ -o $(OBJECTDIR)/cov/alog_tmp.info
	@lcov -e $(OBJECTDIR)/cov/alog_tmp.info "$(PWD)/src/*.adb" -o $(OBJECTDIR)/cov/alog.info
	@genhtml $(OBJECTDIR)/cov/alog.info -o $(COVDIR)

prof: prepare
	@rm -f $(OBJECTDIR)/callgrind.*
	@gnatmake -p -Palog_$(TARGET)_tests -j$(NUM_CPUS) -XALOG_BUILD="profiling"
	@cd $(OBJECTDIR) && \
		valgrind -q --tool=callgrind ./profiler_$(TARGET)
	@cp $(OBJECTDIR)/callgrind.* $(PROFDIR)
	@callgrind_annotate $(PROFDIR)/callgrind.* > $(PROFDIR)/profiler_$(TARGET).txt

.PHONY: cov dist prof tests

=== examples/Makefile ===
#
#  Copyright (c) 2009,
#  Reto Buerki, Adrian-Ken Rueegsegger
#  secunet SwissIT AG
#
#  This file is part of Alog.
#
#  Alog is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation; either version 2.1 of the License, or
#  (at your option) any later version.
#
#  Alog is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with Alog; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
#  MA  02110-1301  USA
#

all: build_examples

build_examples:
	@gnatmake -p -Palog_examples

clean:
	@rm -rf obj

## libalog 0.4.1

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,6 @@
 #
-#  Copyright (c) 2008,
+#  Copyright (c) 2008-2011,
 #  Reto Buerki, Adrian-Ken Rueegsegger
-#  secunet SwissIT AG
 #
 #  This file is part of Alog.
 #
@@ -26,8 +25,9 @@
 TARGET ?= "base"
 
 MAJOR = 0
-MINOR = 3
-VERSION = $(MAJOR).$(MINOR)
+MINOR = 4
+REVISION = 1
+VERSION = $(MAJOR).$(MINOR).$(REVISION)
 ALOG = libalog-$(VERSION)
 SO_LIBRARY = libalog.so.$(VERSION)
 A_LIBRARY = libalog.a
@@ -39,6 +39,7 @@
 COVDIR = cov/$(TARGET)
 PROFDIR = prof/$(TARGET)
 ALI_FILES = lib/$(TARGET)/*.ali
+GPR_FILE = gnat/alog.gpr
 
 TMPDIR = /tmp
 DISTDIR = $(TMPDIR)/$(ALOG)
@@ -47,33 +48,46 @@
 
 NUM_CPUS := $(shell getconf _NPROCESSORS_ONLN)
 
+GMAKE_OPTS = -p -R -j$(NUM_CPUS)
+
+CFLAGS = -fPIC -W -Wall -Werror -O3
+
+LIBGLUE_SOURCES = $(wildcard libglue/*.c)
+LIBGLUE_OBJECTS = $(LIBGLUE_SOURCES:.c=.o)
+
 all: build_lib
 
 tests: build_tests
 	@$(OBJECTDIR)/runner_$(TARGET)
 
 build_lib: prepare
-	@gnatmake -p -Palog_$(TARGET) -j$(NUM_CPUS) -XALOG_VERSION="$(VERSION)" -XLIBRARY_KIND="$(LIBRARY_KIND)"
+	@gnatmake $(GMAKE_OPTS) -Palog_$(TARGET) -XALOG_VERSION="$(VERSION)" -XLIBRARY_KIND="$(LIBRARY_KIND)"
 
-build_tests: prepare
-	@gnatmake -p -Palog_$(TARGET)_tests -j$(NUM_CPUS) -XALOG_BUILD="tests"
+build_tests: prepare obj/lib/libglue.a
+	@gnatmake $(GMAKE_OPTS) -Palog_$(TARGET)_tests -XALOG_BUILD="tests"
 
-prepare: $(SOURCEDIR)/alog-version.ads
+build_all: build_lib build_tests
+
+prepare: $(SOURCEDIR)/alog-version.ads $(LIBGLUE_OBJECTS)
+	@mkdir -p $(OBJECTDIR)/lib
+	@cp $(LIBGLUE_OBJECTS) $(OBJECTDIR)/lib
 	@mkdir -p $(COVDIR) $(PROFDIR)
 
 $(SOURCEDIR)/alog-version.ads:
 	@echo "package Alog.Version is"                 > $@
-	@echo "   Version_Number : constant Float  :="  >> $@
-	@echo "      $(VERSION);"                       >> $@
-	@echo "end Alog.Version;"                       >> $@
+	@echo "   Version_Number : constant String :=" >> $@
+	@echo "      \"$(VERSION)\";"                  >> $@
+	@echo "end Alog.Version;"                      >> $@
 
 clean:
 	@rm -f alog.specs
+	@rm -f $(LIBGLUE_OBJECTS)
 	@rm -rf $(OBJECTDIR)/lib/*
 	@rm -rf $(OBJECTDIR)/*
 	@rm -rf $(LIBDIR)/*
 	@rm -rf $(COVDIR)/*
 	@rm -rf $(PROFDIR)/*
+	$(MAKE) -C doc clean
 
 distclean: clean
 	@rm -rf obj
@@ -95,32 +109,44 @@
 install_lib: build_lib
 	@mkdir -p $(PREFIX)/include/alog
 	@mkdir -p $(PREFIX)/lib/alog
+	@mkdir -p $(PREFIX)/lib/gnat
 	$(INSTALL) -m 644 $(SOURCEDIR)/* $(PREFIX)/include/alog
 	$(INSTALL) -m 444 $(ALI_FILES) $(PREFIX)/lib/alog
+	$(INSTALL) -m 644 $(GPR_FILE) $(PREFIX)/lib/gnat
 
 install_static:
 	$(INSTALL) -m 444 $(LIBDIR)/$(A_LIBRARY) $(PREFIX)/lib/alog
 
 install_dynamic:
 	$(INSTALL) -m 444 $(LIBDIR)/$(SO_LIBRARY) $(PREFIX)/lib/alog
-	@cd $(PREFIX)/lib/alog && \
-	ln -sf $(SO_LIBRARY) libalog.so && \
-	ln -sf $(SO_LIBRARY) libalog.so.$(MAJOR)
+	@cd $(PREFIX)/lib/alog && ln -sf $(SO_LIBRARY) libalog.so
+
+install_tests:
+	$(INSTALL) -v -d $(PREFIX)/tests
+	$(INSTALL) -m 755 $(OBJECTDIR)/runner_$(TARGET) $(PREFIX)/tests/test_runner
+	@cp -vr data $(PREFIX)/tests
 
 cov: prepare
 	@rm -f $(OBJECTDIR)/cov/*.gcda
-	@gnatmake -p -Palog_$(TARGET)_tests -j$(NUM_CPUS) -XALOG_BUILD="coverage"
+	@gnatmake $(GMAKE_OPTS) -Palog_$(TARGET)_tests -XALOG_BUILD="coverage"
 	@$(OBJECTDIR)/cov/runner_$(TARGET) || true
 	@lcov -c -d $(OBJECTDIR)/cov/ -o $(OBJECTDIR)/cov/alog_tmp.info
 	@lcov -e $(OBJECTDIR)/cov/alog_tmp.info "$(PWD)/src/*.adb" -o $(OBJECTDIR)/cov/alog.info
-	@genhtml $(OBJECTDIR)/cov/alog.info -o $(COVDIR)
+	@genhtml --no-branch-coverage $(OBJECTDIR)/cov/alog.info -o $(COVDIR)
 
 prof: prepare
 	@rm -f $(OBJECTDIR)/callgrind.*
-	@gnatmake -p -Palog_$(TARGET)_tests -j$(NUM_CPUS) -XALOG_BUILD="profiling"
+	@gnatmake $(GMAKE_OPTS) -Palog_$(TARGET)_tests -XALOG_BUILD="profiling"
 	@cd $(OBJECTDIR) && \
 		valgrind -q --tool=callgrind ./profiler_$(TARGET)
 	@cp $(OBJECTDIR)/callgrind.* $(PROFDIR)
 	@callgrind_annotate $(PROFDIR)/callgrind.* > $(PROFDIR)/profiler_$(TARGET).txt
 
-.PHONY: cov dist prof tests
+obj/lib/libglue.a: $(LIBGLUE_OBJECTS)
+	@mkdir -p obj/lib
+	$(AR) $(ARFLAGS) $@ $^
+
+doc:
+	$(MAKE) -C doc
+
+.PHONY: cov dist doc prof tests build_all install_tests

=== doc/Makefile ===
DESTDIR   ?= html
STYLEPATH ?= .

ASCIIDOC_OPTS = \
	--backend=xhtml11 \
	--conf-file=page.conf \
	-a stylesdir=$(STYLEPATH) \
	-a linkcss \
	-a disable-javascript \
	-o -

DST_HTML = \
	$(DESTDIR)/index.html \
	$(DESTDIR)/README.html \
	$(DESTDIR)/CHANGELOG.html

all: $(DESTDIR)/asciidoc.css $(DESTDIR)/alog-arch.png $(DST_HTML)

$(DESTDIR)/alog-arch.png: arch/alog-arch.png
	cp $< $@

$(DESTDIR)/asciidoc.css: asciidoc.css
	cp $< $@

$(DESTDIR)/index.html: index page.conf
	asciidoc $(ASCIIDOC_OPTS) $< > $@

$(DESTDIR)/README.html: ../README
	asciidoc $(ASCIIDOC_OPTS) $< > $@

$(DESTDIR)/CHANGELOG.html: ../CHANGELOG
	asciidoc $(ASCIIDOC_OPTS) $< > $@

clean:
	rm -f $(DESTDIR)/*.html
	rm -f $(DESTDIR)/*.css
	rm -f $(DESTDIR)/alog-arch.png

=== examples/Makefile ===
--- 
+++ 
@@ -1,7 +1,6 @@
 #
 #  Copyright (c) 2009,
 #  Reto Buerki, Adrian-Ken Rueegsegger
-#  secunet SwissIT AG
 #
 #  This file is part of Alog.
 #

=== debian/changelog ===
libalog (0.4.1-2) unstable; urgency=low

  * Add project specific git-buildpackage configuration
  * Build dynamic/static libs in separate Obj/Lib dirs (Closes: #663673)
  * Disable tracebacks in Exception occurrences.
    See Debian bug #666106; tracebacks are only disabled on kfreebsd-i386.
    Quilt's guards tool is used to apply this architecture specific patch.

 -- Reto Buerki <reet@codelabs.ch>  Fri, 30 Mar 2012 09:43:30 +0200

libalog (0.4.1-1) unstable; urgency=low

  * Imported upstream version 0.4.1
  * Update to Standards-Version 3.9.3 (no changes)
  * Update to debhelper 8
  * Update Vcs-Git, Vcs-Browser and Homepage URLs
  * Update copyright information
  * Drop unneeded patches
  * Set package names to new library version 0.4.1
  * Migrate to gnat-4.6 (Closes: #642639, #647795)
  * Update GNAT project files
  * Switch to 3.0 (quilt) source package format
  * Install html doc in dev packages
  * Update rules to minimal debhelper syntax
  * Allow Debian Maintainer upload
  * Fix binary-control-field-duplicates-source warning

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Wed, 07 Mar 2012 12:33:05 +0100

libalog (0.3-2) unstable; urgency=low

  * Disable stack checks (Closes: #506681).
  * Use $(QUILT_STAMPFN) instead of patch target.

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Sat, 20 Feb 2010 03:19:18 +0100

libalog (0.3-1) unstable; urgency=low

  * Adding latest debian version (Closes: #514824).
  * Fix dependencies and package names (Closes: #555098, #562378,
    #533153).
  * Convert to latest libaws jabber API.
  * Fix lintian warning debian-watch-file-in-native-package.
  * Adjust install and doc to new package names.
  * Update copyright to include current year.
  * Adjust installed alog project file.
  * Override lintian warnings (false positives).
  * Make alog compilable with libaws2.7.
  * Update to Standards-Version 3.8.4 (no changes).
  * Tighten apq-postgresql dep to version >= 3.0-2.

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Fri, 19 Feb 2010 20:27:13 +0100

libalog (0.1-4) unstable; urgency=low

  * Remove hppa as supported architecture (see #506681).
  * New email addresses.

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Mon, 24 Nov 2008 15:19:19 +0100

libalog (0.1-3) unstable; urgency=low

  * Build against transition of latest ahven package.

 -- Adrian-Ken Rueegsegger <rueegsegger@swiss-it.ch>  Tue, 2 Sep 2008 11:31:29 +0200

libalog (0.1-2) unstable; urgency=low

  * Only building libalog on supported architectures.

 -- Adrian-Ken Rueegsegger <rueegsegger@swiss-it.ch>  Wed, 25 Jun 2008 15:14:42 +0200

libalog (0.1-1) unstable; urgency=low

  * Initial release.
  * Applied gnat-4.3 fixes from git.

 -- Adrian-Ken Rueegsegger <rueegsegger@swiss-it.ch>  Mon, 16 Jun 2008 17:24:10 +0200

=== debian/control ===
Source: libalog
Section: libs
Priority: optional
Maintainer: Adrian-Ken Rueegsegger <ken@codelabs.ch>
Uploaders: Reto Buerki <reet@codelabs.ch>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8), gnat, gnat-4.6, libahven3-dev,
 libaws2.10.2-dev, libapq-postgresql3.2.0-dev, asciidoc, source-highlight, quilt
Standards-Version: 3.9.3
Homepage: http://www.codelabs.ch/alog/
Vcs-Git: http://git.codelabs.ch/git/alog.git
Vcs-Browser: http://git.codelabs.ch/?p=alog.git

Package: libalog0.4.1-base
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gnat-4.6
Conflicts: libalog0.4.1-full
Replaces: libalog0.4.1-full
Description: Logging framework for Ada (base)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog base provides file-based and syslog logging facilities
 and log-level support.

Package: libalog0.4.1-full
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gnat-4.6
Conflicts: libalog0.4.1-base
Replaces: libalog0.4.1-base
Description: Logging framework for Ada (full)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog full offers more facilities than Alog base, notably
 SMTP, PostgreSQL and XMPP/Jabber.

Package: libalog0.4.1-base-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libalog0.4.1-base (= ${binary:Version}), gnat, gnat-4.6
Conflicts: libalog0.4.1-full-dev
Replaces: libalog0.4.1-full-dev
Description: Logging framework for Ada (development)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog base provides file-based and syslog logging facilities
 and log-level support.
 .
 This package contains the development files.

Package: libalog0.4.1-full-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libalog0.4.1-full (= ${binary:Version}), gnat,
 gnat-4.6, libaws2.10.2-dev, libapq-postgresql3.2.0-dev
Conflicts: libalog0.4.1-base-dev
Replaces: libalog0.4.1-base-dev
Description: Logging framework for Ada (development)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog full offers more facilities than Alog base, notably
 SMTP, PostgreSQL and XMPP/Jabber.
 .
 This package contains the development files.

Package: libalog0.4.1-base-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libalog0.4.1-base (= ${binary:Version}),
 libalog0.4.1-base-dev (= ${binary:Version})
Conflicts: libalog0.4.1-full-dbg
Replaces: libalog0.4.1-full-dbg
Description: Logging framework for Ada (debug)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog base provides file-based and syslog logging facilities
 and log-level support.
 .
 This package contains the debugging symbols.

Package: libalog0.4.1-full-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libalog0.4.1-full (= ${binary:Version}),
 libalog0.4.1-full-dev (= ${binary:Version})
Conflicts: libalog0.4.1-base-dbg
Replaces: libalog0.4.1-base-dbg
Description: Logging framework for Ada (debug)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog full offers more facilities than Alog base, notably
 SMTP, PostgreSQL and XMPP/Jabber.
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

PV = 0.4.1
ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh ${@} --with quilt

override_dh_auto_clean:
	$(MAKE) distclean
	rm -rf debian/tmp-*

override_dh_quilt_patch:
	guards --config debian/patches/guards > debian/patches/series $(ARCH)
	dh_quilt_patch

override_dh_auto_build: build-base build-full
	$(MAKE) doc

build-base:
	$(MAKE)
	$(MAKE) LIBRARY_KIND=static
	$(MAKE) tests

build-full:
	$(MAKE) TARGET=full
	$(MAKE) TARGET=full LIBRARY_KIND=static
	$(MAKE) TARGET=full tests


override_dh_auto_install: install-base install-full

install-base:
	$(MAKE) PREFIX=$(CURDIR)/debian/tmp-base/usr install
	$(MAKE) PREFIX=$(CURDIR)/debian/tmp-base/usr LIBRARY_KIND=static install

	mv debian/tmp-base/usr/lib/alog/libalog.* debian/tmp-base/usr/lib

	mkdir -p debian/tmp-base/usr/share/ada/adainclude
	mv debian/tmp-base/usr/include/alog debian/tmp-base/usr/share/ada/adainclude

	mkdir -p debian/tmp-base/usr/lib/ada/adalib/alog
	mv debian/tmp-base/usr/lib/alog/*.ali debian/tmp-base/usr/lib/ada/adalib/alog

	cp debian/misc/alog.gpr debian/tmp-base/usr/share/ada/adainclude
	rm -rf debian/tmp-base/usr/lib/alog
	rm -rf debian/tmp-base/usr/lib/gnat


install-full:
	$(MAKE) TARGET=full PREFIX=$(CURDIR)/debian/tmp-full/usr install
	$(MAKE) TARGET=full PREFIX=$(CURDIR)/debian/tmp-full/usr LIBRARY_KIND=static install

	mv debian/tmp-full/usr/lib/alog/libalog.* debian/tmp-full/usr/lib

	mkdir -p debian/tmp-full/usr/share/ada/adainclude
	mv debian/tmp-full/usr/include/alog debian/tmp-full/usr/share/ada/adainclude

	mkdir -p debian/tmp-full/usr/lib/ada/adalib/alog
	mv debian/tmp-full/usr/lib/alog/*.ali debian/tmp-full/usr/lib/ada/adalib/alog

	cp debian/misc/alog_full.gpr debian/tmp-full/usr/share/ada/adainclude/alog.gpr
	rm -rf debian/tmp-full/usr/lib/alog
	rm -rf debian/tmp-full/usr/lib/gnat

override_dh_install:
	dh_install -p libalog$(PV)-base -p libalog$(PV)-base-dev --fail-missing --sourcedir=debian/tmp-base
	dh_install -p libalog$(PV)-full -p libalog$(PV)-full-dev --fail-missing --sourcedir=debian/tmp-full

override_dh_strip:
	dh_strip -Xlibalog$(PV)-full --dbg-package=libalog$(PV)-base-dbg
	dh_strip -Xlibalog$(PV)-base --dbg-package=libalog$(PV)-full-dbg

## libalog 0.5.0

=== Makefile ===
#
#  Copyright (c) 2008-2014,
#  Reto Buerki, Adrian-Ken Rueegsegger
#
#  This file is part of Alog.
#
#  Alog is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation; either version 2.1 of the License, or
#  (at your option) any later version.
#
#  Alog is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with Alog; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
#  MA  02110-1301  USA
#

PREFIX ?= $(HOME)/libraries
INSTALL = install

MAJOR = 0
MINOR = 5
REVISION = 0
VERSION = $(MAJOR).$(MINOR).$(REVISION)
ALOG = libalog-$(VERSION)
TARBALL = $(ALOG).tar.bz2

SO_LIBRARY = libalog.so.$(VERSION)
A_LIBRARY = libalog.a
LIBRARY_KIND = dynamic

SOURCEDIR = src
OBJECTDIR = obj
LIBDIR = lib
COVDIR = cov
ALI_FILES = lib/$(LIBRARY_KIND)/*.ali
GPR_FILE = gnat/alog.gpr

PWD = `pwd`

NUM_CPUS ?= 1

GMAKE_OPTS = -p -R -j$(NUM_CPUS)

CFLAGS ?= -W -Wall -Werror -O3

all: build_lib

tests: build_tests
	@$(OBJECTDIR)/test_runner

build_lib:
	@gprbuild $(GMAKE_OPTS) -Palog -XALOG_VERSION="$(VERSION)" \
		-XLIBRARY_KIND="$(LIBRARY_KIND)" -XCFLAGS="$(CFLAGS)" \
		-XLDFLAGS="$(LDFLAGS)" -cargs $(ADAFLAGS)

build_tests:
	@gprbuild $(GMAKE_OPTS) -Palog_tests -XALOG_BUILD="tests"

build_all: build_lib build_tests

clean:
	@rm -f $(TARBALL)
	@rm -rf $(OBJECTDIR)
	@rm -rf $(LIBDIR)
	@rm -rf $(COVDIR)
	$(MAKE) -C doc clean

dist:
	@echo "Creating release tarball $(TARBALL) ... "
	@git archive --format=tar HEAD --prefix $(ALOG)/ | bzip2 > $(TARBALL)

install: install_lib install_$(LIBRARY_KIND)

install_lib: build_lib
	@mkdir -p $(PREFIX)/include/alog
	@mkdir -p $(PREFIX)/lib/alog
	@mkdir -p $(PREFIX)/lib/gnat
	$(INSTALL) -m 644 $(SOURCEDIR)/*.ad[bs] $(PREFIX)/include/alog
	$(INSTALL) -m 444 $(ALI_FILES) $(PREFIX)/lib/alog
	$(INSTALL) -m 644 $(GPR_FILE) $(PREFIX)/lib/gnat

install_static:
	$(INSTALL) -m 444 $(LIBDIR)/$(LIBRARY_KIND)/$(A_LIBRARY) $(PREFIX)/lib

install_dynamic:
	$(INSTALL) -m 444 $(LIBDIR)/$(LIBRARY_KIND)/$(SO_LIBRARY) $(PREFIX)/lib
	@cd $(PREFIX)/lib && ln -sf $(SO_LIBRARY) libalog.so

install_tests: build_tests
	$(INSTALL) -v -d $(PREFIX)/tests
	$(INSTALL) -m 755 $(OBJECTDIR)/test_runner $(PREFIX)/tests/
	@cp -vr data $(PREFIX)/tests

cov:
	@mkdir -p $(COVDIR)
	@rm -f $(OBJECTDIR)/cov/*.gcda
	@gprbuild $(GMAKE_OPTS) -Palog_tests -XALOG_BUILD="coverage"
	@$(OBJECTDIR)/cov/test_runner || true
	@lcov -c -d $(OBJECTDIR)/cov/ -o $(OBJECTDIR)/cov/alog_tmp.info
	@lcov -e $(OBJECTDIR)/cov/alog_tmp.info "$(PWD)/src/*.adb" \
		-o $(OBJECTDIR)/cov/alog.info
	@genhtml --no-branch-coverage $(OBJECTDIR)/cov/alog.info -o $(COVDIR)

prof:
	@rm -f $(OBJECTDIR)/callgrind.*
	gprbuild $(GMAKE_OPTS) -Palog_tests -XALOG_BUILD="profiling"
	valgrind -q --tool=callgrind \
		--callgrind-out-file=$(OBJECTDIR)/callgrind.out.%p $(OBJECTDIR)/profiler
	callgrind_annotate $(OBJECTDIR)/callgrind.* > $(OBJECTDIR)/profile.txt

doc:
	$(MAKE) -C doc

.PHONY: cov doc

=== doc/Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 	$(DESTDIR)/README.html \
 	$(DESTDIR)/CHANGELOG.html
 
-all: $(DESTDIR)/asciidoc.css $(DESTDIR)/alog-arch.png $(DST_HTML)
+all: $(DESTDIR) $(DESTDIR)/asciidoc.css $(DESTDIR)/alog-arch.png $(DST_HTML)
 
 $(DESTDIR)/alog-arch.png: arch/alog-arch.png
 	cp $< $@
@@ -31,7 +31,13 @@
 $(DESTDIR)/CHANGELOG.html: ../CHANGELOG
 	asciidoc $(ASCIIDOC_OPTS) $< > $@
 
+$(DESTDIR):
+	mkdir $@
+
 clean:
 	rm -f $(DESTDIR)/*.html
 	rm -f $(DESTDIR)/*.css
 	rm -f $(DESTDIR)/alog-arch.png
+
+distclean:
+	rm -rf $(DESTDIR)

=== debian/changelog ===
libalog (0.5.0-1) unstable; urgency=medium

  * Imported upstream version 0.5.0
  * Remove obsolete DM-Upload-Allowed from debian/control
  * Drop 'full' packages as upstream has removed that functionality
  * Update patches
  * Update binary package names
  * Update package descriptions in debian/control
  * Update to Standards-Version 3.9.6
  * Update Build-Depends in debian/control
  * Enable dpkg-buildflags hardening options
  * Make -dbg package compliant to Debian Ada Policy
  * Transition to gnat-4.9 compiler (Closes: #746082, #755077, #764444)
  * Update ahven Build-Depends to libahven4-dev
  * Update copyright information
  * Update to debhelper 9
  * Simplify debian/rules file
  * Declare NUM_CPUS variable in debian/rules
  * Override dh_compress and dh_auto_test targets
  * Update debian/*.install files
  * Add debian/watch file
  * Add libalog-doc package
  * Add minimal run time test for installed package
  * Decouple the aliversion from the soversion

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Thu, 16 Oct 2014 14:41:55 +0200

=== debian/control ===
Source: libalog
Section: libs
Priority: optional
Maintainer: Adrian-Ken Rueegsegger <ken@codelabs.ch>
Uploaders: Reto Buerki <reet@codelabs.ch>
Build-Depends: debhelper (>= 9), gnat, gnat-4.9, gprbuild, libahven4-dev,
 asciidoc, source-highlight, quilt
Standards-Version: 3.9.6
Homepage: http://www.codelabs.ch/alog/
Vcs-Git: http://git.codelabs.ch/git/alog.git
Vcs-Browser: http://git.codelabs.ch/?p=alog.git
XS-Testsuite: autopkgtest

Package: libalog0.5.0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Logging framework for Ada
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog provides file-based and syslog logging facilities and
 log-level support.

Package: libalog1-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libalog0.5.0 (= ${binary:Version}), gnat, gnat-4.9
Description: Logging framework for Ada (development)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog provides file-based and syslog logging facilities and
 log-level support.
 .
 This package contains the development files.

Package: libalog-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libalog0.5.0 (= ${binary:Version})
Recommends: libalog1-dev (= ${binary:Version})
Suggests: gnat
Description: Logging framework for Ada (debug)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog provides file-based and syslog logging facilities and
 log-level support.
 .
 This package contains the debugging symbols.

Package: libalog-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Logging framework for Ada (documentation)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog provides file-based and syslog logging facilities and
 log-level support.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ADAFLAGS := $(filter-out -Wformat -Werror=format-security, $(CFLAGS))
export ADAFLAGS

NUM_CPUS  = $(shell getconf _NPROCESSORS_ONLN)
MAKE_OPTS = NUM_CPUS=$(NUM_CPUS)

%:
	dh ${@} --with quilt

override_dh_auto_clean:
	$(MAKE) clean
	rm -rf debian/tmp-*

override_dh_quilt_patch:
	guards --config debian/patches/guards > debian/patches/series $(ARCH)
	dh_quilt_patch

override_dh_auto_build:
	$(MAKE)
	$(MAKE) LIBRARY_KIND=static
	$(MAKE) doc

override_dh_auto_install:
	$(MAKE) PREFIX=$(CURDIR)/debian/tmp/usr install
	$(MAKE) PREFIX=$(CURDIR)/debian/tmp/usr LIBRARY_KIND=static install
	rm -rf debian/tmp/usr/lib/gnat
	mkdir -p debian/tmp/usr/share/ada/adainclude
	cp debian/misc/alog.gpr debian/tmp/usr/share/ada/adainclude

override_dh_auto_test:
	$(MAKE) $(MAKE_OPTS) tests

override_dh_install:
	dh_install --fail-missing

override_dh_compress:
	dh_compress -X.ads -X.adb -XMakefile

override_dh_strip:
	dh_strip --dbg-package=libalog-dbg

=== debian/watch ===
version=3
http://www.codelabs.ch/download/libalog-(.*)\.tar\.bz2

## libalog 0.5.2

=== Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 MAJOR = 0
 MINOR = 5
-REVISION = 0
+REVISION = 2
 VERSION = $(MAJOR).$(MINOR).$(REVISION)
 ALOG = libalog-$(VERSION)
 TARBALL = $(ALOG).tar.bz2
@@ -45,9 +45,13 @@
 
 NUM_CPUS ?= 1
 
-GMAKE_OPTS = -p -R -j$(NUM_CPUS)
-
-CFLAGS ?= -W -Wall -Werror -O3
+# GNAT_BUILDER_FLAGS, ADAFLAGS, CFLAGS and GNATFLAGS may be overridden in the
+# environment or on the command line.
+CFLAGS             ?= -W -Wall -Werror -O3
+GNAT_BUILDER_FLAGS ?= -R -j$(NUM_CPUS)
+GNATFLAGS          ?= ${GNAT_BUILDER_FLAGS} -cargs ${ADAFLAGS}
+# GMAKE_OPTS should not be overridden because -p is essential.
+GMAKE_OPTS = -p ${GNATFLAGS} -margs
 
 all: build_lib

=== doc/Makefile ===
--- 
+++ 
@@ -23,13 +23,13 @@
 	cp $< $@
 
 $(DESTDIR)/index.html: index page.conf
-	asciidoc $(ASCIIDOC_OPTS) $< > $@
+	TZ=UTC asciidoc $(ASCIIDOC_OPTS) $< > $@
 
 $(DESTDIR)/README.html: ../README
-	asciidoc $(ASCIIDOC_OPTS) $< > $@
+	TZ=UTC asciidoc $(ASCIIDOC_OPTS) $< > $@
 
 $(DESTDIR)/CHANGELOG.html: ../CHANGELOG
-	asciidoc $(ASCIIDOC_OPTS) $< > $@
+	TZ=UTC asciidoc $(ASCIIDOC_OPTS) $< > $@
 
 $(DESTDIR):
 	mkdir $@

=== examples/Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 all: build_examples
 
 build_examples:
-	@gnatmake -p -Palog_examples
+	@gprbuild -p -Palog_examples
 
 clean:
 	@rm -rf obj

=== debian/changelog ===
libalog (0.5.2-3) unstable; urgency=medium

  [ Nicolas Boulenguez ]
  * Debhelper 10.
  * Tests: remove unused variable, log executed commands.
  * Allow -doc package to satisfy Multi-Arch: same dependencies.
  * HTTPS copyright format URL.
  * Handle DEB_BUILD_OPTIONS=nodoc.
  * Select debian_packaging.mk snippet, there may be many.
  * Replace --fail-missing deprecated debhelper option.
  * Split -arch and -indep targets and Build-Depends.
  * Replace many wildcards with explicit variable expansions.
  * Install GNAT project to /usr/share/gpr.
  * Make the runtime library package Multi-Arch: same.
  * Allow DEB_BUILD_OPTIONS=nocheck.
  * Build with gnat-7 and libahven6-dev (Closes: #872290).

  [ Adrian-Ken Rueegsegger ]
  * Update to Standards-Version 4.1.0
  * Unset LDFLAGS when building static library

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Sun, 10 Sep 2017 22:58:51 +0100

libalog (0.5.2-2) unstable; urgency=medium

  [ Adrian Bunk <bunk@stusta.de> ]
  * Enable PIE build option (Closes: #844886)

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Thu, 29 Dec 2016 21:10:12 +0100

libalog (0.5.2-1) unstable; urgency=medium

  * Imported upstream version 0.5.2 (Closes: #782182)
  * Transition to gnat-6 compiler (Closes: #777934, #833764)
  * Update ahven Build-Depends to libahven5-dev
  * Adjust gprbuild Build-Depends
  * Switch Homepage and Vcs-* URLs to HTTPS
  * Update to Standards-Version 3.9.8
  * Update binary package names
  * Use short-names for lib install & lintian-overrides
  * Drop explicit libalog-dbg package
  * Simplify build by using debian_packaging-*.mk
  * Drop explicit XS-Testsuite
  * Use gprbuild in autopkgtest
  * Add upstream signing key
  * Update watch file to version 4
  * Avoid quilt for arch-dependent patching

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Wed, 17 Aug 2016 16:38:01 +0000

=== debian/control ===
Source: libalog
Section: libs
Priority: optional
Maintainer: Adrian-Ken Rueegsegger <ken@codelabs.ch>
Uploaders: Reto Buerki <reet@codelabs.ch>
Build-Depends: debhelper (>= 10), gprbuild (>= 2015-2),
 gnat, gnat-7,
# This line is parsed by debian/rules.
 libahven6-dev
Build-Depends-Indep: asciidoc, source-highlight
Standards-Version: 4.1.0
Homepage: https://www.codelabs.ch/alog/
Vcs-Git: https://git.codelabs.ch/git/alog.git
Vcs-Browser: https://git.codelabs.ch/?p=alog.git

Package: libalog0.5.2.1
# This line is parsed by debian/rules.
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Logging framework for Ada
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog provides file-based and syslog logging facilities and
 log-level support.

Package: libalog3-dev
# This line is parsed by debian/rules.
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libalog0.5.2.1 (= ${binary:Version}), gnat, gnat-7
Description: Logging framework for Ada (development)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog provides file-based and syslog logging facilities and
 log-level support.
 .
 This package contains the development files.

Package: libalog-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Logging framework for Ada (documentation)
 Alog is a logging framework for Ada and aims to be straight forward to use and
 easily extendable. Alog provides file-based and syslog logging facilities and
 log-level support.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Extract useful information from debian/control.
# Replace eval with warning to debug.
$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/gnat_version:=\1/p;\
  s/^Package: libalog\([0-9.]\+\)$$/soversion:=\1/p;\
  s/^Package: \(libalog[0-9.]\+-dev\)$$/dev_pkg:=\1/p\
  ' debian/control),$(eval $(line)))
lib_pkg := libalog$(soversion)

DPKG_EXPORT_BUILDFLAGS  = 1
DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(gnat_version).mk

export GNAT_BUILDER_FLAGS = $(BUILDER_OPTIONS)

installed_project := debian/alog.gpr

%:
	dh ${@}

override_dh_auto_clean:
	$(MAKE) clean
	rm -f $(installed_project)

override_dh_auto_build-arch:
ifeq ($(DEB_HOST_ARCH),kfreebsd-i386)
	patch -p1 < debian/Don-t-store-tracebacks-in-exception-occurrences.patch
endif
	$(MAKE) VERSION=$(soversion)
	$(MAKE) LDFLAGS= LIBRARY_KIND=static

override_dh_auto_build-arch: $(installed_project)
$(installed_project): debian/template_alog.gpr
	sed s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/ $< > $@

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) doc
endif

override_dh_auto_install-arch:
	$(MAKE) PREFIX=$(CURDIR)/debian/tmp/usr install VERSION=$(soversion)
	$(MAKE) PREFIX=$(CURDIR)/debian/tmp/usr LDFLAGS= LIBRARY_KIND=static install
	rm -rf debian/tmp/usr/lib/gnat

override_dh_auto_install-indep:

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) $(MAKE_OPTS) tests VERSION=$(soversion)
endif

override_dh_install:
	dh_install -p$(lib_pkg) usr/lib/libalog.so.$(soversion) usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(dev_pkg) $(installed_project) usr/share/gpr
	dh_install -p$(dev_pkg) usr/lib/libalog.a usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(dev_pkg) usr/lib/libalog.so usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(dev_pkg) usr/lib/alog/*.ali usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib/alog
	dh_install -p$(dev_pkg) usr/include/alog/*.ad[bs] usr/share/ada/adainclude/alog
	dh_install --remaining-packages
	dh_missing --fail-missing

override_dh_compress:
	dh_compress -X.ads -X.adb -XMakefile

=== debian/watch ===
version=4

opts=pgpsigurlmangle=s/$/.sig/ \
  https://www.codelabs.ch/download/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@ \
  debian uupdate

## libalog 0.5.3

=== Makefile ===
--- 
+++ 
@@ -20,12 +20,14 @@
 #  MA  02110-1301  USA
 #
 
+# DESTDIR and PREFIX have their usual meanings.
 PREFIX ?= $(HOME)/libraries
+
 INSTALL = install
 
 MAJOR = 0
 MINOR = 5
-REVISION = 2
+REVISION = 3
 VERSION = $(MAJOR).$(MINOR).$(REVISION)
 ALOG = libalog-$(VERSION)
 TARBALL = $(ALOG).tar.bz2
@@ -49,22 +51,24 @@
 # environment or on the command line.
 CFLAGS             ?= -W -Wall -Werror -O3
 GNAT_BUILDER_FLAGS ?= -R -j$(NUM_CPUS)
-GNATFLAGS          ?= ${GNAT_BUILDER_FLAGS} -cargs ${ADAFLAGS}
+GNATFLAGS          ?= ${GNAT_BUILDER_FLAGS}
 # GMAKE_OPTS should not be overridden because -p is essential.
-GMAKE_OPTS = -p ${GNATFLAGS} -margs
+GMAKE_OPTS = -g -p ${GNATFLAGS} \
+  $(foreach v,ADAFLAGS CFLAGS CPPFLAGS LDFLAGS,"-X$(v)=$($(v))")
 
 all: build_lib
 
 tests: build_tests
 	@$(OBJECTDIR)/test_runner
 
-build_lib:
-	@gprbuild $(GMAKE_OPTS) -Palog -XALOG_VERSION="$(VERSION)" \
-		-XLIBRARY_KIND="$(LIBRARY_KIND)" -XCFLAGS="$(CFLAGS)" \
-		-XLDFLAGS="$(LDFLAGS)" -cargs $(ADAFLAGS)
+build_lib: build_lib_$(LIBRARY_KIND)
+build_lib_dynamic:
+	@gprbuild $(GMAKE_OPTS) -Palog -XALOG_VERSION="$(VERSION)"
+build_lib_static:
+	@gprbuild $(GMAKE_OPTS) -Palog -XALOG_VERSION=
 
 build_tests:
-	@gprbuild $(GMAKE_OPTS) -Palog_tests -XALOG_BUILD="tests"
+	@gprbuild $(GMAKE_OPTS) -Palog_tests -XALOG_BUILD="tests" -XALOG_VERSION=
 
 build_all: build_lib build_tests
 
@@ -82,29 +86,32 @@
 install: install_lib install_$(LIBRARY_KIND)
 
 install_lib: build_lib
-	@mkdir -p $(PREFIX)/include/alog
-	@mkdir -p $(PREFIX)/lib/alog
-	@mkdir -p $(PREFIX)/lib/gnat
-	$(INSTALL) -m 644 $(SOURCEDIR)/*.ad[bs] $(PREFIX)/include/alog
-	$(INSTALL) -m 444 $(ALI_FILES) $(PREFIX)/lib/alog
-	$(INSTALL) -m 644 $(GPR_FILE) $(PREFIX)/lib/gnat
+	@mkdir -p $(DESTDIR)$(PREFIX)/include/alog
+	@mkdir -p $(DESTDIR)$(PREFIX)/lib/alog
+	@mkdir -p $(DESTDIR)$(PREFIX)/lib/gnat
+	$(INSTALL) -m 644 $(SOURCEDIR)/*.ad[bs] $(DESTDIR)$(PREFIX)/include/alog
+	$(INSTALL) -m 444 $(ALI_FILES) $(DESTDIR)$(PREFIX)/lib/alog
+	$(INSTALL) -m 644 $(GPR_FILE) $(DESTDIR)$(PREFIX)/lib/gnat
 
-install_static:
-	$(INSTALL) -m 444 $(LIBDIR)/$(LIBRARY_KIND)/$(A_LIBRARY) $(PREFIX)/lib
+install_static: $(DESTDIR)$(PREFIX)/lib
+	$(INSTALL) -m 444 $(LIBDIR)/$(LIBRARY_KIND)/$(A_LIBRARY) $<
 
-install_dynamic:
-	$(INSTALL) -m 444 $(LIBDIR)/$(LIBRARY_KIND)/$(SO_LIBRARY) $(PREFIX)/lib
-	@cd $(PREFIX)/lib && ln -sf $(SO_LIBRARY) libalog.so
+install_dynamic: $(DESTDIR)$(PREFIX)/lib
+	$(INSTALL) -m 444 $(LIBDIR)/$(LIBRARY_KIND)/$(SO_LIBRARY) $<
+	@cd $(DESTDIR)$(PREFIX)/lib && ln -sf $(SO_LIBRARY) libalog.so
 
 install_tests: build_tests
-	$(INSTALL) -v -d $(PREFIX)/tests
-	$(INSTALL) -m 755 $(OBJECTDIR)/test_runner $(PREFIX)/tests/
-	@cp -vr data $(PREFIX)/tests
+	$(INSTALL) -v -d $(DESTDIR)$(PREFIX)/tests
+	$(INSTALL) -m 755 $(OBJECTDIR)/test_runner $(DESTDIR)$(PREFIX)/tests/
+	@cp -vr data $(DESTDIR)$(PREFIX)/tests
+
+$(DESTDIR)$(PREFIX)/lib:
+	@mkdir -p $@
 
 cov:
 	@mkdir -p $(COVDIR)
 	@rm -f $(OBJECTDIR)/cov/*.gcda
-	@gprbuild $(GMAKE_OPTS) -Palog_tests -XALOG_BUILD="coverage"
+	@gprbuild $(GMAKE_OPTS) -Palog_tests -XALOG_BUILD="coverage" -XALOG_VERSION=
 	@$(OBJECTDIR)/cov/test_runner || true
 	@lcov -c -d $(OBJECTDIR)/cov/ -o $(OBJECTDIR)/cov/alog_tmp.info
 	@lcov -e $(OBJECTDIR)/cov/alog_tmp.info "$(PWD)/src/*.adb" \
@@ -113,7 +120,7 @@
 
 prof:
 	@rm -f $(OBJECTDIR)/callgrind.*
-	gprbuild $(GMAKE_OPTS) -Palog_tests -XALOG_BUILD="profiling"
+	gprbuild $(GMAKE_OPTS) -Palog_tests -XALOG_BUILD="profiling" -XALOG_VERSION=
 	valgrind -q --tool=callgrind \
 		--callgrind-out-file=$(OBJECTDIR)/callgrind.out.%p $(OBJECTDIR)/profiler
 	callgrind_annotate $(OBJECTDIR)/callgrind.* > $(OBJECTDIR)/profile.txt

=== debian/changelog ===
libalog (0.5.3-2) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:50 +0200

libalog (0.5.3-1) experimental; urgency=medium

  [ Adrian-Ken Rueegsegger ]
  * Update to release 0.5.3
  * Match package versions with upstream 0.5.3 release
  * Add Nicolas Boulenguez to Uploaders

  [ Nicolas Boulenguez ]
  * Move dh_missing to its own override
  * dh_missing now allows one to ignore files
  * Simplify the packaging thanks to new upstream version.
  * VCS-Git: specific branch
  * Debhelper 11, no changes.
  * Mark gprbuild and ahven as arch-dependent dependencies
  * Standards-Version: 4.2.0. Rules-Requires-Root: no.
  * Rebuild with gnat-8 (Closes: #903970)
  * Avoid tests during architecture-independent builds
  * Use dh_ada_library

 -- Adrian-Ken Rueegsegger <ken@codelabs.ch>  Tue, 14 Aug 2018 10:49:39 +0200

=== debian/control ===
--- 
+++ 
@@ -2,18 +2,24 @@
 Section: libs
 Priority: optional
 Maintainer: Adrian-Ken Rueegsegger <ken@codelabs.ch>
-Uploaders: Reto Buerki <reet@codelabs.ch>
-Build-Depends: debhelper (>= 10), gprbuild (>= 2015-2),
- gnat, gnat-7,
+Uploaders: Reto Buerki <reet@codelabs.ch>,
+ Nicolas Boulenguez <nicolas@debian.org>
+Build-Depends:
+ debhelper (>= 11),
+ dh-ada-library,
+ gnat, gnat-8,
 # This line is parsed by debian/rules.
- libahven6-dev
+Build-Depends-Arch:
+ gprbuild (>= 2015-2),
+ libahven7-dev
 Build-Depends-Indep: asciidoc, source-highlight
-Standards-Version: 4.1.0
+Standards-Version: 4.2.0
+Rules-Requires-Root: no
 Homepage: https://www.codelabs.ch/alog/
-Vcs-Git: https://git.codelabs.ch/git/alog.git
+Vcs-Git: https://git.codelabs.ch/git/alog.git -b debian
 Vcs-Browser: https://git.codelabs.ch/?p=alog.git
 
-Package: libalog0.5.2.1
+Package: libalog0.5.3.1
 # This line is parsed by debian/rules.
 Architecture: any
 Multi-Arch: same
@@ -23,11 +29,10 @@
  easily extendable. Alog provides file-based and syslog logging facilities and
  log-level support.
 
-Package: libalog3-dev
-# This line is parsed by debian/rules.
+Package: libalog4-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libalog0.5.2.1 (= ${binary:Version}), gnat, gnat-7
+Depends: ${misc:Depends}, ${ada:Depends}
 Description: Logging framework for Ada (development)
  Alog is a logging framework for Ada and aims to be straight forward to use and
  easily extendable. Alog provides file-based and syslog logging facilities and

=== debian/rules ===
#!/usr/bin/make -f

# Extract useful information from debian/control.
# Replace eval with warning to debug.
$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/gnat_version:=\1/p;\
  s/^Package: libalog\([0-9.]\+\)$$/soversion:=\1/p;\
  ' debian/control),$(eval $(line)))
lib_pkg := libalog$(soversion)

DPKG_EXPORT_BUILDFLAGS  = 1
DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/debian_packaging-$(gnat_version).mk

export GNAT_BUILDER_FLAGS = $(BUILDER_OPTIONS)

%:
	dh ${@} --with ada-library

override_dh_auto_build-arch:
ifeq ($(DEB_HOST_ARCH),kfreebsd-i386)
	patch -p1 < debian/Don-t-store-tracebacks-in-exception-occurrences.patch
endif
	$(MAKE) VERSION=$(soversion)
	$(MAKE) LIBRARY_KIND=static

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) doc
endif

override_dh_auto_install:

override_dh_auto_test-indep:
override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) $(MAKE_OPTS) tests
endif

override_dh_compress:
	dh_compress -X.ads -X.adb -XMakefile
